﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using UltimateCorp.Palette;

namespace TestPalette
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler? PropertyChanged;
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;
        }

        private void SetAll(string uri)
        {
            this.cartkern.Content = uri.ToImage();
            this.cartkern2.Content = uri.ToImage();
            this.cartkern3.Content = uri.ToImage();
            this.cartkern4.Content = uri.ToImage();
        }

        private void SetCartman(object sender, RoutedEventArgs e) => SetAll("cartman");
        private void SetKenny(object sender, RoutedEventArgs e) => SetAll("kenny");
        private void SetMysterion(object sender, RoutedEventArgs e) => SetAll("mysterion");      

        #region AnimationTimeA
        private double _AnimationTimeA = 300D;
        public double AnimationTimeA
        {
            get => _AnimationTimeA;
            set
            {
                _AnimationTimeA = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("AnimationTimeA"));
            }
        }
        #endregion

        #region AnimationTimeB
        private double _AnimationTimeB = 301D;
        public double AnimationTimeB
        {
            get => _AnimationTimeB;
            set
            {
                _AnimationTimeB = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("AnimationTimeB"));
            }
        }
        #endregion

        #region AnimationTimeC
        private double _AnimationTimeC = 302D;
        public double AnimationTimeC
        {
            get => _AnimationTimeC;
            set
            {
                _AnimationTimeC = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("AnimationTimeC"));
            }
        }
        #endregion

        #region AnimationTimeD
        private double _AnimationTimeD = 100D;
        public double AnimationTimeD
        {
            get => _AnimationTimeD;
            set
            {
                _AnimationTimeD = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("AnimationTimeD"));
            }
        }
        #endregion

        #region AnimationTimeE
        private double _AnimationTimeE = 10D;
        public double AnimationTimeE
        {
            get => _AnimationTimeE;
            set
            {
                _AnimationTimeE = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("AnimationTimeE"));
            }
        }
        #endregion

        #region Animation Numeric 1/2/3/4
        bool isRunning = false;
        private void AnimNumeric(object sender, RoutedEventArgs e)
        {
            EndAnimationEventHandler d = null;
            if (!isRunning)
            {
                isRunning = true;
                int i = 25;
                d = new EndAnimationEventHandler(() =>
                {
                    if (isRunning)
                    {
                        this.numeric.Content = new TextBlock()
                        {
                            Text = i.ToString(),
                            FontSize = 50,
                            FontFamily = new FontFamily("./#gunplay")
                        };                       
                        i++;
                    }
                });
                numeric.EndAnim += d;
                d();
            }
            else
            {
                isRunning = false;
                numeric.EndAnim -= d;
            }
        }

        bool isRunning2 = false;
        private void AnimNumeric2(object sender, RoutedEventArgs e)
        {
            EndAnimationEventHandler d = null;
            if (!isRunning2)
            {
                isRunning2 = true;
                int i = 25;
                d = new EndAnimationEventHandler(() =>
                {
                    if (isRunning2)
                    {
                        this.numeric2.Content = new TextBlock()
                        {
                            Text = i.ToString(),
                            FontSize = 50,
                            FontFamily = new FontFamily("./#gunplay")
                        };
                        i++;
                    }
                });
                numeric2.EndAnim += d;
                d();
            }
            else
            {
                isRunning2 = false;
                numeric2.EndAnim -= d;
            }
        }

        bool isRunning3 = false;
        private void AnimNumeric3(object sender, RoutedEventArgs e)
        {
            EndAnimationEventHandler d = null;
            if (!isRunning3)
            {
                isRunning3 = true;
                int i = 25;
                d = new EndAnimationEventHandler(() =>
                {
                    if (isRunning3)
                    {
                        this.numeric3.Content = new TextBlock()
                        {
                            Text = i.ToString(),
                            FontSize = 50,
                            FontFamily = new FontFamily("./#gunplay")
                        };
                        i++;
                    }
                });
                numeric3.EndAnim += d;
                d();
            }
            else
            {
                isRunning3 = false;
                numeric3.EndAnim -= d;
            }
        }

        bool isRunning4 = false;
        private void AnimNumeric4(object sender, RoutedEventArgs e)
        {
            EndAnimationEventHandler d = null;
            if (!isRunning4)
            {
                isRunning4 = true;
                int i = 25;
                d = new EndAnimationEventHandler(() =>
                {
                    if (isRunning4)
                    {
                        this.numeric4.Content = new TextBlock()
                        {
                            Text = i.ToString(),
                            FontSize = 50,
                            FontFamily = new FontFamily("./#gunplay")
                        };
                        i++;
                    }
                });
                numeric4.EndAnim += d;
                d();
            }
            else
            {
                isRunning4 = false;
                numeric4.EndAnim -= d;
            }
        }
        #endregion

        #region TextA
        private string _TextA = null;
        public string TextA
        {
            get => _TextA;
            set
            {
                _TextA = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("TextA"));
            }
        }
        #endregion

        #region TextB
        private string _TextB = "CC";
        public string TextB
        {
            get => _TextB;
            set
            {
                _TextB = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("TextB"));
            }
        }
        #endregion

        #region TextC
        private string _TextC = "z";
        public string TextC
        {
            get => _TextC;
            set
            {
                _TextC = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("TextC"));
            }
        }
        #endregion

        #region TextD
        private string _TextD = null;
        public string TextD
        {
            get => _TextD;
            set
            {
                _TextD = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("TextD"));
            }
        }
        #endregion

        #region BoolA
        private bool _BoolA = false;
        public bool BoolA
        {
            get => _BoolA;
            set
            {
                _BoolA = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("BoolA"));
            }
        }
        #endregion

        #region StringA
        private string _StringA = "a";
        public string StringA
        {
            get => _StringA;
            set
            {
                _StringA = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("StringA"));
            }
        }
        #endregion

        #region StringB
        private string _StringB = "paris-toulouse       12h15";
        public string StringB
        {
            get => _StringB;
            set
            {
                _StringB = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("StringB"));
            }
        }
        #endregion

        #region IntA
        private int _IntA = 5;
        public int IntA
        {
            get => _IntA;
            set
            {
                _IntA = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("IntA"));
            }
        }
        #endregion

        Random r = new Random();
        private void SET(object sender, RoutedEventArgs e)
        {
            if (this.bpc.Content == null)
            {
                this.bpc.Content = "A";
                this.bpc.FontSize = r.NextInt64(40) + 12;
            }
            else
                this.bpc.Content = null;
        }

        double at = 0;
        private void PTC5_top(object sender, RoutedEventArgs e)
        {
            at = (at + 10) % 60;
            this.ptc5.AdjustTop = -at;
        }

        double at2 = 0;
        private void Top2(object sender, RoutedEventArgs e)
        {
            at2 = (at2 + 1) % 60;
            this.ptt3.AdjustTop = -at2;            
        }

        private void SwitchPause(object sender, RoutedEventArgs e)
        {
            BoolA = !BoolA;
        }

        string[] sx = new string[]
        {
            "sample",
            "for show",
            "possibility",
            "of this control",
          // 1234567890123456
            "thanks for",
            "showing",
            ""
        };

        private void AllAnim(object sender, RoutedEventArgs e)
        {
            int i = 0;
            StringA = sx[i++];
            EndAnimationEventHandler d = null;
            d = () => {
                Thread.Sleep(1000);
                if (i >= sx.Length)
                {
                    s0.CompletAnim -= d;
                }
                else
                    StringA = sx[i++];
            };
            s0.CompletAnim += d;
        }

        #region SepeVisibility
        private Visibility _SepeVisibility = Visibility.Visible;
        public Visibility SepeVisibility
        {
            get => _SepeVisibility;
            set
            {
                _SepeVisibility = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("SepeVisibility"));
            }
        }
        #endregion

        private void ptc_anim_SecondTickEvent(object sender, RoutedEventArgs e)
        {
            SepeVisibility = Visibility.Hidden;    
            new Thread(() =>
            {
                Thread.Sleep(500);
                SepeVisibility = Visibility.Visible;
            }) { IsBackground=true }.Start();
        }

        string[] ar = new string[]
        { 
//           1234567890123456     
            " only for test",
            " this array control",
            " possibility",
             " thanks for",
            " showing",
            ""
        };

        private void SetArray(object sender, RoutedEventArgs e)
        {
            this.s1.Array = ar;
        }

        private void ClearArray(object sender, RoutedEventArgs e)
        {
            this.s1.Array = null;
        }

        string[] atest = new string[]
        { 
//           1234567890123456     
            "Test control for",
            "show only informations",
            "and stop"
        };
        private void ArrayTest(object sender, RoutedEventArgs e)
        {
            this.s1.Array = atest;
        }

        private void ArrayInfo(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine((string)this.s1.Info());
        }

        private void SetM(object sender, RoutedEventArgs e)
        {
            StringA = "mmmmmmmmmmmmmmmmmmmmmmmmmmmmm";
        }
        private void SetA(object sender, RoutedEventArgs e)
        {
            StringA = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
        }

        private void SampleColor(object sender, RoutedEventArgs e)
        {
            //"paris-toulouse       12h15";
            int i = 0;
            ClearColor(null, null);
            EndAnimationEventHandler anim = null;
            anim = () =>
            {
                Thread.Sleep(2000);
                switch (++i)
                {
                    case 1:
                        SetColor(null, null);                        
                        StringB = "paris-toulouse    canceled";
                        break;
                    default:
                        s00.CompletAnim -= anim;
                        break;
                }
            };
            s00.CompletAnim += anim;
            StringB= "paris-toulouse            ";
        }

        private void SetColor(object sender, RoutedEventArgs e)
        {
            List<Brush> list = new List<Brush>();
            for (int b = 0; b < 15; b++)
            {
                list.Add(Brushes.White);
            }
            for (int b = 0; b < 15; b++)
            {
                list.Add(Brushes.Yellow);
            }
            s00.ArrayBrush = list.ToArray();
        }

        private void ClearColor(object sender, RoutedEventArgs e)
        {
            s00.ArrayBrush= null;
        }
    }

    public static class ImageExtension
    {
        public static Image ToImage(this string uri)
        {
            return new Image()
            {
                Source = new BitmapImage(new Uri($"/{uri}.png", UriKind.RelativeOrAbsolute)),
                Width = 90,
                Height = 90
            };
        }
    }
}
