﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace UltimateCorp.Palette
{
    public abstract class BasePaletteDefinition : PaletteTextControl
    {
        public event EndAnimationEventHandler CompletAnim;
        private void OnCompleteAnim()
        {
            CompletAnim?.Invoke();
        }

        #region OnAnim
        private bool _OnAnim = false;
        public bool OnAnim
        {
            get => _OnAnim;
            private set { _OnAnim = value; OnPropertyChanged(); }
        }
        #endregion

        protected abstract string DefinitionCase { get; }
        protected abstract string DefinitionNoCase { get; }

        protected override void SetAll(SetMode mode = SetMode.All)
        {
            base.SetAll(mode);
        }

        #region MoveTo
        int pos = -1;
        int toValue = -1;

        protected void MoveTo(string from, string to)
        {
            int ps = 0, pe = 0;
            if (!string.IsNullOrEmpty(from))
            {
                ps = DefinitionNoCase.LastIndexOf(from[0]);
            }
            if (!string.IsNullOrEmpty(to))
            {
                pe = DefinitionNoCase.LastIndexOf(to[0]);
            }
            MoveTo(ps, pe);
        }
        bool nextQuit = false;
        protected void MoveTo(int from, int to)
        {
            pos = (from + 1) % DefinitionCase.Length;
            toValue = to;
            //
            EndAnimationEventHandler endA = null;
            nextQuit = false;
            endA = () =>
            {                
                if (nextQuit)
                {
                    this.EndAnim -= endA;
                    OnAnim = false;
                    RaiseEvents();
                    OnCompleteAnim();
                }
                this.Text = DefinitionCase[pos].ToString();
                if (pos == toValue)
                {
                    nextQuit = true;              
                }
                else
                {
                    pos = (pos + 1) % DefinitionCase.Length;
                }
            };
            if (OnAnim) { }
            else
            {
                OnAnim = true;
                this.EndAnim += endA;
                endA();
            }
        }
        #endregion
    }
}
