﻿//#define SHOW_DEBUG

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace UltimateCorp.Palette
{
    public class PaletteNumericControl : BasePaletteDefinition
    {
        protected override string DefinitionCase => "0123456789";
        protected override string DefinitionNoCase => DefinitionCase;

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            if (Value == 0) { this.Text = "0"; }
        }

        #region Value
        [Category("Palette")]
        public int Value { get => (int)GetValue(ValueProperty); set => SetValue(ValueProperty, value); }
        public static readonly DependencyProperty ValueProperty =
            DependencyProperty.Register("Value",
                    typeof(int),
                    typeof(PaletteNumericControl),
                    new PropertyMetadata(0
                    , (ss, ee) =>
                    {
                        if (ss is PaletteNumericControl pnc)
                        {
                            if (!pnc.IsInitialized || DesignerProperties.GetIsInDesignMode(pnc))
                            {
                                pnc.Text = ee.NewValue.ToString();
                                pnc.SetAll();
                            }
                            else
                            {
                                string from = ee.OldValue.ToString();
                                string to = ee.NewValue.ToString();
                                if (!from.Equals(to)) pnc.MoveTo(from, to);
                            }
                        }
                    }
                    , (ss, ee) =>
                     {
                         int r = 0;
                         try
                         {
                             r = (int)ee;
                             if (r < 0) r = 0;
                             else if (r > 9) r = 9;
                         }
                         catch { }
                         return r;
                     }));
        #endregion
    }
}
