﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace UltimateCorp.Palette
{
    public class PaletteTextControl : BasePaletteAnimation
    {     
        #region Text
        [Category("Palette")]
        public string Text { get => (string)GetValue(TextProperty); set => SetValue(TextProperty, value); }
        public static readonly DependencyProperty TextProperty =
            DependencyProperty.Register("Text",
                        typeof(string),
                        typeof(PaletteTextControl),
                        new PropertyMetadata(null
                        , (ss, ee) =>
                        {
                            var ptc = ss as PaletteTextControl;
                            if (DesignerProperties.GetIsInDesignMode(ptc) ||
                                     ptc.DisableAnim || !ptc.IsInitialized)
                            {
                                ptc.SetAll();
                            }
                            else
                            {
                                var e = ee.OldValue;
                                var z = ee.NewValue;
                                if (e is string s) e = new TextBlock() { Text = s };
                                ptc.StartAnimation(e as UIElement);
                            }
                        }));
        #endregion

        protected override UIElement GetContent => new TextBlock() { Text = Text };
        protected override bool HasContent => true;
    }
}

