﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Markup;

namespace UltimateCorp.Palette
{
    public enum CornerRadiusConvertPosition
    {
        Top,
        Bottom,
    }
    public class CornerRadiusConverter : MarkupExtension, IValueConverter
    {
        #region Position
        private CornerRadiusConvertPosition _Position = CornerRadiusConvertPosition.Top;
        public CornerRadiusConvertPosition Position
        {
            get => _Position;
            set { _Position = value; }
        }
        #endregion

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            CornerRadius cr = (CornerRadius)value;
            if (Position == CornerRadiusConvertPosition.Top)
                return new CornerRadius(cr.TopLeft, cr.TopRight, 0, 0);
            else
                return new CornerRadius(0 , 0, cr.BottomRight, cr.BottomLeft);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        public override object ProvideValue(IServiceProvider serviceProvider) => this;      
    }
}
