﻿using System;
using System.Collections.Generic;
using sd=System.Diagnostics;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace UltimateCorp.Palette
{
    public delegate void DebugMessageEventHandler(string message, string memberName, string sourceFilePath, int sourceLineNumber);

    public static class StringExtension
    {
        public static event DebugMessageEventHandler OnDebugMessage;
        public static bool ShortFilePath { get; set; } = true;

        public static void Debug(this string message,
                    [CallerMemberName] string memberName = "",
                    [CallerFilePath] string sourceFilePath = "",
                    [CallerLineNumber] int sourceLineNumber = 0)
        {
            var fp = !ShortFilePath ? sourceFilePath : Path.GetFileName(sourceFilePath);
            sd.Debug.WriteLine($"{DateTime.Now.ToString()} - {fp} :  {memberName}({sourceLineNumber}) = {message}");
            OnDebugMessage?.Invoke(message, memberName, sourceFilePath, sourceLineNumber);
        }
    }
}
